%define debug_package %{nil}
%define __SCL	%(if [ -d /opt/rh/python27 ]; then echo 1; else echo 0; fi)

%define _rbindir %{_exec_prefix}/bin
%if 0%{?__SCL} > 0 
       %define PYTHON     python27
        %define python_sitelib_old_1 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)")
        %define python_sitelib_old_2 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)")
        %define python_sitelib %(echo python -c '"from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)"' | scl enable python27 -)
        %define _SCL_base %(echo $(dirname $(dirname `echo which python | scl enable python27 -`)))
        %define _bindir %(dirname `echo which python | scl enable python27 -`)
        %define _datadir %{_SCL_base}/share
        %define _mandir %{_datadir}/man
        %define _docdir %{_datadir}/doc
        %define  __os_install_post      \
            /usr/lib/rpm/redhat/brp-compress; \
            %{!?__debug_package:/usr/lib/rpm/redhat/brp-strip %{__strip}}; \
            /usr/lib/rpm/redhat/brp-strip-static-archive %{__strip}; \
            /usr/lib/rpm/redhat/brp-strip-comment-note %{__strip} %{__objdump}; \
            echo /usr/lib/rpm/brp-python-bytecompile python27 | scl enable %{PYTHON} - ; \
            /usr/lib/rpm/redhat/brp-python-hardlink; \
            %{!?__jar_repack:/usr/lib/rpm/redhat/brp-java-repack-jars}

%else
	%define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)")
%endif


Name:           bokken
Version:        1.8
Release:        2%{?dist}
License:        LGPL-3.0
Source:         https://inguma.eu/projects/bokken/%{name}-%{version}.tar.gz
Group:          Development/Tools/Debuggers
Url:            http://www.radare.org
Summary:	GUI for the Pyew and Radare projects 
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if 0%{?__SCL} > 0
BuildRequires:  python27-python-setuptools
Requires:       python27-python-setuptools
Requires:	python-imaging
Requires:	librsvg2
%else
BuildRequires:  python(abi) => 2.7
%endif
Requires:	%{__python}
Requires:	python-radare
Requires:	python-tidy
Requires:	pygtk2
Requires:	pygtksourceview
Requires:	graphviz

%description
Bokken is a GUI for the Pyew and Radare projects so it offers almost all
the same features that Pyew has and and some of the Radare's ones. It's
intended to be a basic disassembler, mainly, to analyze malware and
vulnerabilities.

Currently Bokken is neither an hexadecimal editor nor a full featured
disassembler YET, so it should not be used for deep code analysis or to
try to modify files with it.

%prep
%setup
########################################################################
# The system script that computes dependencies misidentifies the 
# python 2.7 dependency, so it is necessary to remove it from the
# dependency determination. 
########################################################################
%if 0%{?__SCL} > 0
mkdir -p %{_builddir}/%{name}-%{version}
cat > %{_builddir}/%{name}-%{version}/pythondeps.sh << \EOF
#!/bin/sh
%{__python_requires} $* | sed -e 's/python(abi) = 2.7/python27-python(abi) = 2.7/'
EOF
chmod +x %{_builddir}/%{name}-%{version}/pythondeps.sh
%define __python_requires %{_builddir}/%{name}-%{version}/pythondeps.sh
%endif

%build
%{__install} -m755 -d %{buildroot}%{python_sitelib}/%{name}
cp -rp . %{buildroot}%{python_sitelib}/%{name}
%if 0%{?__SCL} > 0
%{__install} -m755 -d %{buildroot}%{_rbindir}
cat > %{buildroot}%{_rbindir}/%{name} << 'EOF' 
#!/bin/sh

export PYTHONPATH=%{python_sitelib}:%{python_sitelib_old_1}:%{python_sitelib_old_2}
BOKKEN_DIR=%{python_sitelib}/bokken

echo python $BOKKEN_DIR/bokken.py "$@" | scl enable python27 -
EOF
%else
%{__install} -m755 -d %{buildroot}%{_bindir}
sed	-e 's=BOKKEN_DIR\=.*=BOKKEN_DIR\=%{python_sitelib}/%{name}='	\
	-e 's=PYTHON_EXECUTABLE\=.*=PYTHON_EXECUTABLE\=%{__python}=' 			\
	-e 's/python -V/$PYTHON_EXECUTABLE -V/'						\
		< %{name} > %{buildroot}%{_rbindir}/%{name}
%endif
cd %{buildroot}%{python_sitelib}/%{name}
rm Changelog README LICENSE TODO .gitignore

%files
%doc Changelog README LICENSE
%attr(755, root, root)	%{_rbindir}/%{name}
%attr(644, root, root)	%{python_sitelib}/%{name}/bokken
%attr(644, root, root)	%{python_sitelib}/%{name}/*.*
%attr(644, root, root)	%{python_sitelib}/%{name}/*/*.*
%attr(644, root, root)	%{python_sitelib}/%{name}/*/*/*.*
%attr(644, root, root)	%{python_sitelib}/%{name}/*/*/*/*.*

%changelog
* Wed Jun 10 2015 Lawrence R. Rogers <lrr@cert.org> 1.8
* Release 1.7
	Release 1.8 (10-06-2015
	 * Removed pyew entirely.  Its support has been in a non-official deprecated
	   state for the past two years but we were trying not to do it.  Pyew has
	   some dependencies that makes harder to package it, it's missing a lot of
	   features from r2, plus it sees very few releases.
	 * Removed other almost useless features in their current form: Strings repr
	   and Interactive mode.  We expect to bring those at some point in a proper
	   way.
	 * Added r2 console.  It crashes here and there but we think it's rather
	   usable.
	 * Added interactive Python console.
	 * Rearranged and simplified some tabs: Strings, Relocs and File info.
	 * Some additional cleanups and fixes.

* Tue May  5 2015 Lawrence R. Rogers <lrr@cert.org> 1.7
* Release 1.7
	Release 1.7 (04-05-2015)
	 * General refactoring of functions and classes to make them more abstract and generic.
	 * Added new experimental web server (Mune) based on webpy with command-line
	   flag --web.  It's very incomplete but the idea is to keep making it a
	   first-class citizen in subsequent releases.
	 * Fixed a lot of usability bugs, weird bugs, corner cases, unhandled
	   exceptions and the like.
	 * Revamped all the search dialogs, moved them to a new tab and fixed some
	   bugs in the meantime.
	 * Added compatibility with radare2 up to 0.9.8.
	 * Added support for base address in radare.
	 * Updated xdot to latest version.
	 * Fixed Add comment functionality.
	 * Added click-to-go and highlighting the search string.
